#pragma once

#include <stdbool.h>
#include "list_elm.h"

typedef struct list {
	list_elm_t * head;
	list_elm_t* tail;
	int numelm;
} list_t;

list_t * new_list();
void del_list ( list_t * * L, void (*ptrf) () );
bool empty_list ( list_t * L );

list_elm_t * get_head ( list_t * L );
list_elm_t * get_tail ( list_t * L );
void view_list ( list_t * L, void (*ptrf)() );

void cons ( list_t * L, void * data );
void queue ( list_t * L, void * data );
void ordered_insert ( list_t * L, void * data, int (*cmpFct)() );

int get_numelm(list_t * L);

// void take_out(struct list_t * L, void * D);
void quick_sort(list_t * L, int (*cmpFct)()); 
void find(list_t * L, void ** ptrKey, int (*cmpFct)(), void (*delFct)());
void del_list(list_t ** ptrL, void (*ptrf) ());
void clean(list_t * L);
bool is_empty(list_t * L);

	
