#include "job.h"
#include "list.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

job_t * new_empty_job(){
    job_t * J = calloc ( 1, sizeof (job_t ) );
    assert( J );
    J->precedence = new_list ( );
    J->posteriority = new_list ( );
    J->rank = UNDEF;
    J->au_plus_tard = UNDEF;
    J->au_plus_tot = UNDEF;
    J->marge_totale = UNDEF;
    J->critique = false;
    return J;
}

job_t * new_job(char * title){
    job_t * J = new_empty_job ( );
    J->title = strdup ( title );
    return J;
}

void free_job(job_t ** ptrJ){
    assert ( ptrJ && *ptrJ );
    if( (*ptrJ)->title ) free ( (*ptrJ)->title );
    free ( *ptrJ );
    *ptrJ = NULL;
}

void view_job ( job_t * J ) {
    printf ( "JOB %s\n\tpreceeded by [", get_job_tilte ( J ) );
    for(elmlist_t * E = get_head ( J->precedence ); E; E = get_suc ( E ) ) {
        printf ( " %s", get_job_tilte ( get_data ( E ) ) );
    }
    printf ( " ]\n" );
    // if ( !get_numelm ( J->posteriority ) ) printf ( "\t" );
    printf ( "\tfollowed by [" );
    for(elmlist_t * E = get_head(J->posteriority); E; E = get_suc(E)){
        printf(" %s", get_job_tilte(get_data(E)));
    }
    printf ( " ]\n" );
    printf ( "\tiDeg=%d\toDeg=%d\tlife=%2.2lf", J->input_degree, J->output_degree, J->life );
    printf ( "\trank=" );
    if ( J->rank == UNDEF ) printf ( "U" ); else printf ( "%d", J->rank );
    printf ( "\tearly=" );
    if(J->au_plus_tot == UNDEF ) printf("U"); else printf ( "%2.2lf",J->au_plus_tot );
    printf ( "\tlate=" );
    if(J->au_plus_tard == UNDEF ) printf("U"); else printf ( "%2.2lf",J->au_plus_tard );
    printf ( "\ttotale= " );
    if ( J->marge_totale == UNDEF ) printf("U"); else printf ( "%2.2lf", J->marge_totale );
    printf ( "\tcritical= " );
    if ( J->critique ) printf("Y\n"); else printf ( "N\n" );
}

char * get_job_title(job_t * J) {
    assert(J);
    return J->title;
}

void titleJobCmp(job_t * J, char * title){



}

void set_job_title(job_t * J, char * title) {
    assert(J && title);
    if(J->title)
        free(J->title);
    J->title = strdup(title);
}


double get_job_life(job_t * J) {
    assert(J);
    return J->life;
}


void set_job_life(job_t * J, double life) {
    assert(J);
    J->life = life;
}


int get_job_iDegree(job_t * J) {
    assert(J);
    return J->input_degree;
}


void set_job_iDegree(job_t * J, int iDegree) {
    assert(J);
    J->input_degree = iDegree;
}


void incr_job_iDegree(job_t * J) {
    assert(J);
    J->input_degree++;
}


void decr_job_iDegree(job_t * J) {
    assert(J);
    J->input_degree--;
}